// Grab and Drag extension by Ian Weiner: ian.weiner (at) gmail.com
//
// See license.txt for more information (GPL)

//TO DO:
// Clean up code. Back to time limited?
// Improve scrolling smoothness- Vary interval delay intelligently? 
// compromise to allow very slow scrolling?
// Override links option?
// way to restart at same speed?

const gadFF = 0; const gadTB = 1; 
const gadVERSION = "1.5.0";

const gadPrefListener = {
  domain: "grabAndDrag.",
  observe: function(subject, topic, prefName) {
    gadInit();
  }
}

function mod(m,n) {	return (m>=0?m%n:(n-((n-m)%n))%n); } // mod should always be positive!

function gadStack(k) {
	this.entries = new Array(k);
	this.length=0; this.next=0; this.n=k;
	this.add=add; this.clear=clear; this.val=val; this.sum=sum; this.avg=avg; 
	this.sumWithin=sumWithin; this.maxabs=maxabs; this.minabs=minabs;
	function add(x) {
		this.entries[this.next]=x; 
		if (this.length < this.n) this.length++;
		this.next=mod(this.next+1,this.n);
	}
	function clear() { this.length=0; }
	function val(m) { return this.entries[mod(this.next-1-m,this.n)]; }
	function sum() { var i; var tot=0; for (i=0; i<this.length; i++) tot+=this.val(i); return tot; }
	function avg(m,N) { 
		var i; var tot=0; N=Math.min(N,this.length-1);
		for (i=m; i<=N; i++) tot+=this.val(i); 
		return tot/(N-m+1); 
	}
	function sumWithin(D) { 
		var dist=0, i; 
		for (i=0; (dist<D)&&(i<this.length); i++) dist+=this.val(i);
		return i-1;
	}
	function maxabs(m,N) { 
		var i; var v=Math.abs(this.val(m)); N=Math.min(N,this.length-1);
		for (i=m; i<=N; i++) v=Math.max(v,Math.abs(this.val(i))); 
		return v; 
	}
	function minabs(m,N) { 
		var i; var v=Math.abs(this.val(m)); N=Math.min(N,this.length-1);
		for (i=m; i<=N; i++) v=Math.min(v,Math.abs(this.val(i))); 
		return v; 
	}
}

var gadContentArea, gadRenderingArea, gadAppContent, gadMainWin;
var gadScrollObj;
var gadStartX, gadStartY, gadLastX, gadLastY, gadLastMoveX, gadLastMoveY, 
	gadLastTime, gadLastVel;
var gadOn, gadVer, gadFirstTime=false;
var gadStdCursor, gadDragCursor, gadQuickKey, gadDragInc, gadMult, gadSBMode;
var gadTogKey, gadUseCtrl, gadUseAlt, gadUseShift, gadGeckoVers;
var gadMoveTime, gadFlickOn, gadFlickSpeed, gadFlickTimeLimit, gadHasMoved;
var gadInQT, gadWasScrolling, gadAppPlatform, gadDragDoc, gadS="";

var gadScrollIntervalObj, gadScrollLoopInterval, gadScrollLastLoop, gadScrollLastMoveLoop;
var gadScrollToGo, gadSmoothStop, gadSmoothFactor, gadScrollHoriz;
var gadScrollVel, gadScrollVelMult, gadScrollDistance, gadScrollMaxInterval;
var gadDists = new gadStack(50), gadVels = new gadStack(50), gadTimes = new gadStack(50);
var gadMomOn, gadMomExtent, gadMomVariation;

var gadPrefService = Components.classes["@mozilla.org/preferences-service;1"]
                     .getService(Components.interfaces.nsIPrefService);
var gadPref = gadPrefService.getBranch("grabAndDrag.");
var gadPrefRoot = gadPrefService.getBranch(null);
var gadPbi = gadPrefRoot.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
gadPbi.addObserver(gadPrefListener.domain, gadPrefListener, false);


function gadClose() 
{
	gadPbi.removeObserver(gadPrefListener.domain, gadPrefListener);
  	gadRenderingArea.removeEventListener("mousedown", gadDownHandler, true);
  	gadRenderingArea.removeEventListener("click",gadClickHandler, true);
    gadAppContent.removeEventListener("DOMContentLoaded", gadLoad, true);
	 gadContentArea.removeEventListener("dragover", gadUpHandler, false);
	 gadAppContent.removeEventListener("click",gadClickPreempt, true);
	 window.removeEventListener("mouseup", gadUpHandler, true);
	 window.removeEventListener("mouseout", gadUpHandler, true);
   	 window.removeEventListener("mousedown", gadUpHandler, true);
     window.removeEventListener("mousemove", gadMoveScrollBar, true);
	 window.removeEventListener("keydown", gadKeyDownHandler, false);
     window.removeEventListener("keyup", gadKeyUpHandler, false);
    window.removeEventListener("DOMNodeInserted", gadButtonAdd, false);
	
	gadContentArea=null; gadRenderingArea=null; gadAppContent=null; gadMainWin=null;
	gadScrollObj=null; gadPrefService=null; gadPref=null;
	gadPrefRoot=null; 
	gadPbi=null;	
}

function gadButtonAdd(e) {
	var bu = e.target.firstChild;
	if (bu) if (bu.id=="grabanddrag-button") 
		document.getElementById("grabanddrag-button").setAttribute("gadOn",gadOn);
}

function gadInit() {  
  //gadGeckoVers = parseFloat(window.navigator.userAgent.substring(window.navigator.userAgent.lastIndexOf("rv:") + 3));

  gadInQT=false; gadWasScrolling=false; gadHasMoved = false;
  gadOn = gadPref.getBoolPref("on");
  gadVer = gadPref.getCharPref("version");
  if (gadVer != gadVERSION) {
    gadPref.setCharPref("version", gadVERSION); 
    window.openDialog("chrome://grabanddrag/content/gadPrefs.xul", "gadPrefs", "chrome");
  }
  gadQuickKey = gadPref.getIntPref("quickToggleKeyEvent");
  gadTogKey = gadPref.getIntPref("togKey");
  gadUseCtrl = gadPref.getBoolPref("useCtrl");
  gadUseAlt = gadPref.getBoolPref("useAlt");
  gadUseShift = gadPref.getBoolPref("useShift");
  gadDragInc = parseFloat(gadPref.getCharPref("dragInc"));
  gadMult = (gadPref.getBoolPref("reverse")?(-1):(1))*parseFloat(gadPref.getCharPref("mult"));
  gadSBMode = gadPref.getBoolPref("sbmode");
  gadStdCursor = gadPref.getCharPref("grabCursor");
  if (gadPref.getBoolPref("samecur")) gadDragCursor = gadStdCursor;
  else gadDragCursor = gadPref.getCharPref("grabbingCursor");	 
  gadFlickOn = gadPref.getBoolPref("flickon");
  gadFlickSpeed = parseFloat(gadPref.getCharPref("flickspeed_ppms"));
  gadFlickTimeLimit = parseFloat(gadPref.getCharPref("flicktimelimit"));
  gadMomOn = gadPref.getBoolPref("momOn");
  gadMomVariation = parseFloat(gadPref.getCharPref("momVariation"));
  gadMomExtent = parseFloat(gadPref.getCharPref("momExtent")); 
  gadSmoothStop = gadPref.getBoolPref("smoothStop");
  
  // determine which app we're running under, firefox/flock or thunderbird
  if (document.getElementById("main-window")) {
    gadAppPlatform=gadFF; 
    gadMainWin = document.getElementById("main-window");
    gadContentArea = document.getElementById("content");
    gadRenderingArea = gadContentArea.mPanelContainer;
    gadAppContent = document.getElementById("appcontent");
  } else { 
    gadAppPlatform=gadTB; 
    gadMainWin = document.getElementById("messengerWindow");
    gadContentArea = document.getElementById("messagepane");
    gadRenderingArea = document.getElementById("messagepane");
    gadAppContent = document.getElementById("messengerWindow");
  }

  if (gadOn) { 
	 window.goDoCommand('cmd_selectNone'); 
  	 gadRenderingArea.addEventListener("mousedown", gadDownHandler, true);
	 gadRenderingArea.addEventListener("click",gadClickHandler, true);
     gadAppContent.addEventListener("click",gadClickPreempt, true);
     gadAppContent.addEventListener("DOMContentLoaded", gadLoad, true);
	 window.addEventListener("keydown", gadKeyDownHandler, false);
     window.addEventListener("keyup", gadKeyUpHandler, false);
  } else {	   
  	 gadRenderingArea.removeEventListener("mousedown", gadDownHandler, true);
  	 gadRenderingArea.removeEventListener("click",gadClickHandler, true);
     gadAppContent.removeEventListener("DOMContentLoaded", gadLoad, true);
	 gadContentArea.removeEventListener("dragover", gadUpHandler, false);
	 gadAppContent.removeEventListener("click",gadClickPreempt, true);
	 window.removeEventListener("mouseup", gadUpHandler, true);
	 window.removeEventListener("mouseout", gadUpHandler, true);
   	 window.removeEventListener("mousedown", gadUpHandler, true);
     window.removeEventListener("mousemove", gadMoveScrollBar, true);
	 window.removeEventListener("keydown", gadKeyDownHandler, false);
     window.removeEventListener("keyup", gadKeyUpHandler, false);
  }

  gadUpdateGraphics();
}

//preempt the normal image size toggling to allow dragging of images
// also preempt clicks triggered by drags, clicks meant to stop momentum
function gadClickPreempt(e) { 
	if ((e.originalTarget.ownerDocument.toggleImageSize && 
				e.originalTarget.nodeName.toLowerCase()=="img" && e.button==0) || 
				gadWasScrolling || gadHasMoved) { 
		e.preventDefault(); e.stopPropagation(); 
		gadWasScrolling=false; gadHasMoved=false;
		return false;
	}
}

function gadToggleKeyHandler(e) 
{
	if ((e.keyCode==gadTogKey) && (e.ctrlKey == gadUseCtrl) && 
						(e.altKey == gadUseAlt) && (e.shiftKey == gadUseShift)) {
		gadToggle();
	}
}

function gadKeyDownHandler(e) {
	if (gadScrollIntervalObj) {
		window.clearInterval(gadScrollIntervalObj); 
		gadScrollIntervalObj = null;
	}
	if (e.keyCode==gadQuickKey && !gadInQT) { 
		gadSetCursor(e.target.ownerDocument, "auto",false); 
		gadInQT=true; 
		window.setCursor("auto");
		e.preventDefault(); e.stopPropagation(); return false;
	} 
}

function gadKeyUpHandler(e) { 
	if (e.keyCode==gadQuickKey) { 
		gadInQT=false; 
		gadSetCursor(e.target.ownerDocument, gadStdCursor, false); 
		e.preventDefault(); e.stopPropagation(); return false;
	}
}

function gadSetCursor(doc, cur, deep) {
	if (!doc) return;
	if (doc.body) {
		if (doc.designMode) if (doc.designMode=="on") cur="auto"; // don't change cursor in design mode docs
    	if (doc.body.style.cursor != cur) {
			doc.body.style.setProperty("cursor", cur, "important");
		}
    }
    if (deep) {
		var i;		
		var x = doc.evaluate("//frame | //iframe", doc, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE,null);
		if (x) {
			for (i=0; i<x.snapshotLength; i++) {
				gadSetCursor(x.snapshotItem(i).contentDocument,cur,deep);
			}
		}
	}
}

function gadLoad(e) {
	gadSetCursor(e.target, gadStdCursor,false);
}
 
function gadUpdateGraphics() {
	var b, bu;

	bu = document.getElementById("grabanddrag-button");
    if (bu) bu.setAttribute("gadOn",gadOn);
   	
  	try {
   		if (gadAppPlatform==gadFF) {
     		for (var i=0; b = gadContentArea.browsers[i]; i++) {
				try { gadSetCursor(b.contentDocument,(gadOn?gadStdCursor:"auto"),true); } catch(err) { }
     		}
   		} else { 
     		try { gadSetCursor(gadRenderingArea.contentDocument,(gadOn?gadStdCursor:"auto"),true); } catch(err) { }
   		}
	} catch(err) { } 
}

function gadToggle() {
   try { gadPref.setBoolPref("on", !gadOn); } catch(err) { }
}

function gadOnItem(initialNode) {
  var nextNode, currNode, currNodeUnsafe;
  var doc = initialNode.ownerDocument;
  var st = doc.defaultView.getComputedStyle(initialNode, "");
  var cur = st.getPropertyValue("cursor");

  if (doc.imageResizingEnabled) return false; 
  if (doc.designMode) if (doc.designMode=="on") return true;  // Gmail html mode editing, e.g.
  if (st.getPropertyValue("-moz-user-select")=="none") return true; //hack for Google maps...
  if ((cur != gadStdCursor) && (cur != "auto")) return true;
  
  nextNode = initialNode; 
  do {
        currNode = nextNode; 
		if (currNode.wrappedJSObject) currNodeUnsafe=currNode.wrappedJSObject;
		else currNodeUnsafe=currNode;
        try { 
		   if ((currNodeUnsafe.ondrag) || (currNodeUnsafe.onmousedown) || 
               (currNodeUnsafe.onmouseup) || (currNodeUnsafe.ondragover)) 
              return true; 
           if (currNode.hasAttribute("href")) return true; 
           if (currNode.nodeName.toLowerCase() == "textarea") 
              return !(currNode.getAttribute("disabled") || currNode.getAttribute("readonly"));
		   if ((currNode.nodeName.toLowerCase() == "scrollbar") ||
      		   (currNode.nodeName.toLowerCase() == "input") ||
               (currNode.nodeName.toLowerCase() == "select") ||
      		   (currNode.nodeName.toLowerCase() == "option") ||
      		   (currNode.nodeName.toLowerCase() == "embed") ||
      		   (currNode.nodeName.toLowerCase() == "object") ||
      		   (currNode.nodeName.toLowerCase() == "tree") ||
      		   (currNode.nodeName.toLowerCase() == "applet") ||
      		   (currNode.nodeName.toLowerCase() == "statusbar")) return true; 
        } catch(err) { }
        nextNode = currNode.parentNode;
  } while (nextNode && currNode != doc.documentElement);
  
  return false;
}

function gadDownHandler(e) {  
  	var t = e.originalTarget;
  	gadHasMoved = false; gadMoveTime=0;
  	gadWasScrolling = (gadScrollIntervalObj)?true:false;
  	if ((!gadWasScrolling) && (e.button!=0 || gadOnItem(t) || gadInQT)) return true; 
	if (gadScrollIntervalObj) {
		window.clearInterval(gadScrollIntervalObj); 
		gadScrollIntervalObj = null;
		e.stopPropagation();
	}
  	e.preventDefault();    
  	gadContentArea.addEventListener("dragover", gadUpHandler, false);
  	gadScrollObj = gadFindNodeToScroll(t);
  	window.addEventListener("mouseup", gadUpHandler, true);
  	//window.addEventListener("mouseout", gadUpHandler, true);
  	window.addEventListener("mousemove", gadMoveScrollBar, true);
	gadDragDoc = t.ownerDocument;
  	if (gadScrollObj.scrollType == 3) return false;
  	gadRenderingArea.removeEventListener("mousedown", gadDownHandler, true);
  	window.addEventListener("mousedown", gadUpHandler, true);
  	gadStartY = e.screenY; gadStartX = e.screenX;
  	gadLastY = e.screenY; gadLastX = e.screenX;
  	gadLastMoveY = e.screenY; gadLastMoveX = e.screenX;
  	gadLastVel = 0;
  	gadLastTime=(new Date()).getTime(); 
  	gadDists.clear(); gadVels.clear(); gadTimes.clear();
	if (gadStdCursor!=gadDragCursor) {
		try { gadSetCursor(t.ownerDocument, gadDragCursor, false); } catch(err) { }
	}
  	return false;
}

function gadMoveScrollBar(e) {
   var horiz, time, dX, dY, dT, dD, vel;

   e.preventDefault(); e.stopPropagation();    
   time = (new Date()).getTime();
   dT = time-gadLastTime; 
   dX = gadLastX - e.screenX;  dY = gadLastY - e.screenY;
   dXM = gadLastMoveX - e.screenX;  dYM = gadLastMoveY - e.screenY;
   horiz = (Math.abs(dX) > Math.abs(dY));
   // ignore slight quick movements 
   if (!gadHasMoved && dT<=50 && 
   			Math.abs(gadStartX-e.screenX)<=2 && Math.abs(gadStartY-e.screenY)<=2) {
	   return;
   }
   if (!gadHasMoved && (Math.abs(gadStartX-e.screenX) > 2 || Math.abs(gadStartY-e.screenY) > 2)) {
	   gadHasMoved = true;
	   gadMoveTime = time;
   }
   dX*=gadScrollObj.ratioX;
   dY*=gadScrollObj.ratioY;
   

	if (gadFlickOn||gadMomOn) {
   		if (horiz) dD = dX; else dD = dY;
   		if (dT==0) return;
		vel = dD/dT;   
		//accel = sgn(dD)*(vel - gadLastVel)/dT;
		if ((gadScrollHoriz!=horiz) || (dD*gadLastVel<0)) {  
			gadDists.clear(); gadVels.clear(); gadTimes.clear();
		}
		gadDists.add(dD); gadVels.add(vel); gadTimes.add(dT);
		gadScrollHoriz = horiz; gadLastVel = vel;
	}
	gadLastTime = time; gadLastY = e.screenY; gadLastX = e.screenX; 

   if ((Math.abs(dXM)>=gadDragInc) || (Math.abs(dYM)>=gadDragInc)) {
	   switch (gadScrollObj.scrollType) {
	     case 1: gadScrollObj.scrollYBy(Math.ceil(dYM));
	             break;
	     case 2: gadScrollObj.scrollXBy(Math.ceil(dXM));
	             break;
	     case 0: if (horiz) gadScrollObj.scrollXBy(Math.ceil(dXM));
	             else gadScrollObj.scrollYBy(Math.ceil(dYM));             
	   }
	   gadLastMoveY = e.screenY; gadLastMoveX = e.screenX;
   }
}

function gadBigDecel() 
{	
	var N = gadTimes.sumWithin(gadMomExtent);
	return (gadVels.maxabs(0,1)/gadVels.maxabs(0,N) < gadMomVariation);
}

function gadUpHandler(e) {
	var time = (new Date()).getTime(); 
	// ignore mouseout bubbling unless we leave the window
	if (e.type == "mouseout") if (e.relatedTarget) return; 
   	window.removeEventListener("mousemove", gadMoveScrollBar, true);
   	window.removeEventListener("mouseup", gadUpHandler, true);
   	window.removeEventListener("mouseout", gadUpHandler, true);
   	window.removeEventListener("mousedown", gadUpHandler, true);
   	gadContentArea.removeEventListener("dragover", gadUpHandler, false);     	
	var dT = time-gadLastTime;
	var aT = gadTimes.avg(1,20);
	// handle flick gestures and momentum
	if ( (dT<2*aT) && (gadFlickOn||gadMomOn) ) {
		var dist, vel, interval, DXt, DYt, totCurDist;
		DXt = gadStartX - e.screenX; DYt = gadStartY - e.screenY;	
		DXt*=gadScrollObj.ratioX; DYt*=gadScrollObj.ratioY; 
		dX*=gadScrollObj.ratioX; dY*=gadScrollObj.ratioY; 
		
		totCurDist = Math.abs(gadDists.sum()/(gadScrollHoriz?gadScrollObj.ratioX:gadScrollObj.ratioY));
		interval=5 // 200fps
		gadScrollMaxInterval = aT*3;
		if (gadFlickOn && (!gadWasScrolling) && (time-gadMoveTime < gadFlickTimeLimit)) {
			vel = sgn(gadVels.val(0))*gadFlickSpeed;
			if (gadScrollHoriz) dist = sgn(vel)*(gadScrollObj.realWidth - 15 - Math.abs(DXt));
			else dist = sgn(vel)*(gadScrollObj.realHeight - 25 - Math.abs(DYt));
			gadInitScroll(dist,interval,vel,gadScrollHoriz);
		} else if (gadMomOn) {
			if (!gadBigDecel() && (totCurDist > 10) && 
						(gadTimes.sum() > gadMomExtent/4) && (gadDists.length>1)) {
				vel = sgn(gadVels.val(0))*gadVels.maxabs(0,1);
				if (gadScrollHoriz) dist = sgn(vel)*(gadScrollObj.scrollW);
				else dist = sgn(vel)*(gadScrollObj.scrollH);
				gadInitScroll(dist,interval,vel,gadScrollHoriz);
			}
		}
	}
	var t = e.originalTarget;
	if (gadStdCursor!=gadDragCursor) {
		try { gadSetCursor(gadDragDoc, gadStdCursor,false); } catch(err) { }
	}
	gadDragDoc=null;
   	e.preventDefault();       
   	gadRenderingArea.addEventListener("mousedown", gadDownHandler, true);
   	if (!gadHasMoved && (t.ownerDocument.toggleImageSize)) {
		t.ownerDocument.toggleImageSize(); 
	}
}

function gadFixFocus(n) {
	var fr;
	var focused = document.commandDispatcher.focusedElement;
	if (focused) focused.blur();
	content.focus();
	if (n.ownerDocument.defaultView.frameElement) {
		fr = n.ownerDocument.defaultView.frameElement.contentWindow;
		if (fr) fr.focus();
	}
}

//handle some useful default browser click actions that we prevented with preventDefault 
//above.
function gadClickHandler(e) {
	var t = e.originalTarget;
	if (gadOnItem(t) || e.button != 0 || gadHasMoved) return; 
 	if (gadInQT) { e.preventDefault(); return; }
 	gadFixFocus(e.originalTarget);
	window.goDoCommand('cmd_selectNone'); 
}

function sgn(n) { if (n<0) return -1; if (n>0) return 1; return 0; }

function gadInitScroll(dist,interval,vel,horiz)
{
	gadScrollLastLoop = (new Date()).getTime();
	
	if (gadScrollIntervalObj) window.clearInterval(gadScrollIntervalObj); 
	var destination;
	gadScrollSmooth=gadSmoothStop;
	gadSmoothFactor=2;
	if (horiz) {
		destination = gadScrollObj.scrollLeft + dist;
		if (destination <= 0) { 
			dist = -gadScrollObj.scrollLeft; 
			gadSmoothFactor=3; 
		} else if (destination >= gadScrollObj.scrollW-gadScrollObj.realWidth)  {
			dist = gadScrollObj.scrollW-gadScrollObj.realWidth-gadScrollObj.scrollLeft;
			gadSmoothFactor=3; 
		}
	} else {
		destination = gadScrollObj.scrollTop + dist;
		if (destination <= 0) {
			dist = -gadScrollObj.scrollTop;
			gadSmoothFactor=3; 
		} else if (destination >= gadScrollObj.scrollH-gadScrollObj.realHeight)  {
			dist = gadScrollObj.scrollH-gadScrollObj.realHeight-gadScrollObj.scrollTop;
			gadSmoothFactor=3; 
		}
	}
	gadScrollLoopInterval = interval;
    gadScrollVel = vel;
    gadScrollVelMult = 1;
	gadScrollHoriz = horiz;
	gadScrollToGo = dist;
	gadScrollDistance = dist;
	gadScrollLastMoveLoop = gadScrollLastLoop;
    gadScrollIntervalObj = window.setInterval(gadScrollLoop,gadScrollLoopInterval);
	gadScrollLoop();
}

function gadScrollLoop() {
	var toScroll, currentTime, dT, tCk;
	currentTime=(new Date()).getTime();
	// make sure previous loop is done
	if (gadScrollLastLoop==currentTime) {
		window.clearInterval(gadScrollIntervalObj);
		gadScrollIntervalObj = window.setInterval(gadScrollLoop,gadScrollLoopInterval);
		return;
	}
	gadScrollLastLoop = currentTime;
	dT = currentTime-gadScrollLastMoveLoop;
	//gadS = ", " + dT + gadS; // debug

	// the following line sacrifices constant speed for smoother motion when the loop is delayed a lot
	if (currentTime-gadScrollLastLoop>gadScrollMaxInterval) dT=gadScrollMaxInterval;
	
	toScroll = Math.round(gadScrollVel*gadScrollVelMult*dT);	
	if ( (Math.abs(toScroll)<gadDragInc*gadScrollVelMult) &&
				(Math.abs(gadScrollToGo)>=gadDragInc*gadScrollVelMult) ) return;
	if ((toScroll==0)&&(gadScrollToGo!=0)) return; // this must be before velocity scaling below or loop may not end
	if ((gadScrollToGo-toScroll)*sgn(gadScrollToGo) <= 0) {
		toScroll=gadScrollToGo;
	}	
	// fast (tho somewhat inaccurate) hack to smoothly stop
	tCk = Math.max(30,dT)*gadSmoothFactor*gadScrollVel;
	while (gadScrollSmooth && ((gadScrollToGo-tCk*gadScrollVelMult)*sgn(gadScrollToGo) < 0)) {
		// it's important that we take ceil below so the last pixel always finishes
		toScroll=sgn(toScroll)*Math.ceil(Math.abs(toScroll)/2);  
		gadScrollVelMult*=0.3;
	}
	gadScrollLastMoveLoop = gadScrollLastLoop;

	if (gadScrollHoriz) gadScrollObj.scrollXBy(toScroll);
	else gadScrollObj.scrollYBy(toScroll);
	gadScrollToGo -= toScroll;

	if (gadScrollToGo==0){
		window.clearInterval(gadScrollIntervalObj);
		gadScrollIntervalObj=null;
		//alert("["+gadScrollMaxInterval+"]"+gadS); // debug
		return;
	}
}

// The following is modified from Marc Boullet's All-in-one Gestures extension
function gadFindNodeToScroll(initialNode) {

  function getStyle(elem, aProp) {
    var p = elem.ownerDocument.defaultView.getComputedStyle(elem, "").getPropertyValue(aProp);
    var val = parseFloat(p);
    if (!isNaN(val)) return Math.ceil(val);
    if (p == "thin") return 1;
    if (p == "medium") return 3;
    if (p == "thick") return 5;
    return 0;
  }

  function scrollCursorType(neededW, availW, neededH, availH, scrollBarSize) {
    if (neededW <= availW && neededH <= availH) return 3;
    if (neededW > availW && neededH > availH) return 0;
    if (neededW > availW) return ((neededH <= (availH - scrollBarSize)) - 0) << 1;  // 0 or 2
    return (neededW <= (availW - scrollBarSize)) - 0;
  }
  
  const defaultScrollBarSize = 16;
  const twiceScrollBarSize = defaultScrollBarSize * 2;
  var retObj = {scrollType: 3, isXML: false, nodeToScroll: null, ratioX: 1,
                ratioY: 1, clientFrame: null, isBody: false, isFrame: false,
                targetDoc: null, insertionNode: null, realHeight: 1, realWidth: 1, 
                scrollXBy: null, scrollYBy: null, scrollW: 1, scrollH: 1 };
  var realWidth, realHeight, nextNode, currNode;
  var targetDoc = initialNode.ownerDocument;
  var docEl = targetDoc.documentElement;
  retObj.insertionNode = (docEl) ? docEl : targetDoc;
  var docBox = targetDoc.getBoxObjectFor(retObj.insertionNode);
  var clientFrame = targetDoc.defaultView;
  retObj.targetDoc = targetDoc; retObj.clientFrame = clientFrame;
  if (docEl && docEl.nodeName.toLowerCase() == "html") { // walk the tree up looking for something to scroll
     if (clientFrame.frameElement) retObj.isFrame = true; else retObj.isFrame = false;
     var bodies = docEl.getElementsByTagName("body");
     if (!bodies || !bodies.length) return retObj;
     var bodyEl = bodies[0];
     if (initialNode == docEl) nextNode = bodyEl;
     else if (initialNode.nodeName.toLowerCase() == "select") nextNode = initialNode.parentNode;
          else nextNode = initialNode;
     do {
        try {
          currNode = nextNode;
          if (currNode.clientWidth && currNode.clientHeight &&
             currNode.ownerDocument.defaultView.getComputedStyle(currNode, "").getPropertyValue("overflow") != "hidden") {
             realWidth = currNode.clientWidth + getStyle(currNode, "border-left-width") + getStyle(currNode, "border-right-width");
             realHeight = currNode.clientHeight + getStyle(currNode, "border-top-width") + getStyle(currNode, "border-bottom-width");
             retObj.scrollType = scrollCursorType(currNode.scrollWidth, realWidth, currNode.scrollHeight, realHeight, 0);
             if (retObj.scrollType != 3) {
                retObj.nodeToScroll = currNode;
                retObj.isBody = currNode == bodyEl || currNode == docEl;
                if (realWidth > twiceScrollBarSize) realWidth -= twiceScrollBarSize;
                if (realHeight > twiceScrollBarSize) realHeight -= twiceScrollBarSize;
                if (gadSBMode) {
	                retObj.ratioX = -currNode.scrollWidth/realWidth;
                	retObj.ratioY = -currNode.scrollHeight/realHeight;
            	} else {
	                retObj.ratioX = gadMult;
                	retObj.ratioY = gadMult;
            	}	    
            	retObj.scrollW = currNode.scrollWidth-twiceScrollBarSize; 
            	retObj.scrollH = currNode.scrollHeight-twiceScrollBarSize;
                retObj.realWidth = realWidth;
                retObj.realHeight = realHeight;
				retObj.scrollXBy = function(dx) { this.nodeToScroll.scrollLeft += dx; }
     			retObj.scrollYBy = function(dy) { this.nodeToScroll.scrollTop += dy; }
     			retObj.__defineGetter__("scrollTop",function(){return this.nodeToScroll.scrollTop;});
     			retObj.__defineGetter__("scrollLeft",function(){return this.nodeToScroll.scrollLeft;});
                return retObj;
             }
          }
          nextNode = currNode.parentNode;
        }
        catch(err) {return retObj;}
     } while (nextNode && currNode != docEl);
     if (retObj.isFrame) return gadFindNodeToScroll(clientFrame.frameElement.ownerDocument.documentElement);
  }
  else { // XML document; do our best
     retObj.nodeToScroll = initialNode;
     if (docBox) {
        if (gadSBMode) {
        	retObj.ratioX = -docBox.width/gadRenderingArea.boxObject.width;
        	retObj.ratioY = -docBox.height/gadRenderingArea.boxObject.height;
    	} else {
            retObj.ratioX = gadMult;
        	retObj.ratioY = gadMult;
    	}	            	
    	retObj.scrollW = docBox.width;
    	retObj.scrollH = docBox.height;
        retObj.realWidth = gadRenderingArea.boxObject.width;
        retObj.realHeight = gadRenderingArea.boxObject.height;
        try { retObj.scrollType = scrollCursorType(docBox.width, gadRenderingArea.boxObject.width,
                   docBox.height, gadRenderingArea.boxObject.height, defaultScrollBarSize); } catch(err) { }
     }
     retObj.isXML = true;
     retObj.scrollXBy = function(dx) { this.clientFrame.scrollBy(dx,0); }
     retObj.scrollYBy = function(dy) { this.clientFrame.scrollBy(0,dy); }
     retObj.__defineGetter__("scrollTop",function(){return this.clientFrame.scrollY;});
     retObj.__defineGetter__("scrollLeft",function(){return this.clientFrame.scrollX;});
  }
  return retObj;
}
// End AiOG

